Non-Uniqueness of Minimal Superpermutations
Abstract
We examine the open problem of finding the shortest string that contains each of the permutations of symbols as contiguous substrings (i.e., the shortest superpermutation on symbols). It has been conjectured that the shortest superpermutation has length and that this string is unique up to relabelling of the symbols. We provide a construction of short superpermutations that shows that, if the conjectured minimal length is true, then uniqueness fails for all . Furthermore, uniqueness fails spectacularly; we construct more than doubly-exponentially many distinct superpermutations of the conjectured minimal length.
keywords:
superpermutation \seppermutation \sepshortest superstring1 Introduction
The shortest superstring problem asks for the shortest string containing each string in a given set as a contiguous substring. The shortest superstring problem is NP-hardΒ GMS80 in general, and finding algorithms for computing or approximating shortest superstrings is an active area of research GL01 ; KS05 .
In certain special cases, the shortest superstring problem simplifies considerably. Perhaps most well-known of these cases arises when the set of substrings consists of all words of length on symbols, where and are given positive integers. There are such words, so there is a trivial lower bound of length on any string containing them all as substrings. More interestingly, however, it has been shown AB51 that this length is always attainable. A string containing all such words that attains this minimal length is called a De Bruijn sequence.
In the present paper, we consider the related problem that arises when the set of substrings contains all permutations of symbols. That is, we are interested in the problem that asks for the shortest string on the symbols that contains all permutations of those symbols as contiguous substrings. Following the terminology of AT93 , we call a string containing all permutations in this way a superpermutation, and we call a superpermutation of minimum length a minimal superpermutation.
Similar to the De Bruijn sequence case, there are permutations of symbols, so a trivial lower bound on the length of a minimal superpermutation is . Unlike in the De Bruijn sequence case, however, this bound is not tight when . For a minimal superpermutation is trivially , which contains both permutations and as substrings. For it is not difficult to show that a shortest string containing each of , , , , , and as contiguous substrings is . For small values of , the optimal solutions have been computed via brute-force computer search A180632 β TableΒ 1 summarizes the shortest strings for .
Computing minimal superpermutations for isnβt feasible via brute-force, but the solutions for provide some structure that is easily generalized. For example, there is a natural recursive construction that can be used to create small superpermutations on symbols for any (more specifically, superpermutations of length ), and this procedure produces the superpermutations provided in TableΒ 1 when . This method of constructing small superpermutations has been rediscovered independently in several different forms AT93 ; JBweb ; JOweb ; YFweb ; kolistivra and it gives, for all , what are currently the only known superpermutations of length at most . Furthermore, the superpermutations provided in TableΒ 1 have been shown by brute force to be unique up to relabelling the symbols (e.g., the only minimal superpermutations in the case are and , which are related to each other by swapping the roles of and ).
These observations have led to the following conjectures:
Conjecture 1 (AT93 ; A180632 ; JBweb ; JOweb ; YFweb ; JBweb2 ).
The length of the minimal superpermutation on symbols is .
Conjecture 2 (AT93 ).
The minimal superpermutation on symbols is unique up to interchanging the roles of the symbols.
In this work we generalize the well-known method of construction of small superpermutations in a new way. Our construction shows that, for all , at least one of these two conjectures fails. It is known that ConjectureΒ 1 has to at least be βalmostβ true in the sense that the conjectured length canβt be too far from the true minimal length (AT93, , TheoremΒ 18). On the other hand, our construction shows that if ConjectureΒ 1 is true, then ConjectureΒ 2 fails spectacularly as increases. For example, our construction in the case provides more than distinct superpermutations of the conjectured minimal length.
Before proceeding, we present the notational conventions and representations of permutations that we will use throughout this paper. In order to avoid double-counting superpermutations that are related to each other by interchanging the roles of the symbols, we only consider superpermutations that begin with the substring . We typically represent a permutation via its one-line representation , which we think of as a string (for example, the identity permutation corresponds to the string ).
It is also sometimes useful for us to represent a permutation by another encoding that we now describe. Define to be the permutation that cyclically increases the first positive integers by one and acts as the identity otherwise: if , if , and . Then cyclically increases the first positive integers by and acts as the identity otherwise, and for every permutation , there is a unique tuple of exponents with for all so that . To write in this way, first choose so that the correct integer is mapped to , then choose so that the correct integer is mapped to , and so on. To see uniqueness, we simply note that there are exactly tuples satisfying for all , which is the same as the size of .
Rather than explicitly writing a permutation in the form , we simply write the exponents in order within square brackets and a subscript , as in . We call this representation the circular shift representation. For example, both (one-line notation) and (circular shift representation) represent the same permutation.
As perhaps a slightly more intuitive way of converting a permutationβs circular shift representation to its one-line representation, start with the string . Cycle the first characters of the string to the left the number of times indicated by , then cycle the first characters of the string to the left the number of times indicated by , and so on. So to obtain the one-line representation of , we start with and transform it as follows:
2 Construction of a Small Superpermutation
In this section we briefly present a well-known method for constructing a family of strings with the property that is a superpermutation on of length .
First, let , the string with just one symbol. Then we construct from via the following procedure:
-
(a)
Let () be the th permutation of that appears as a substring of .
-
(b)
Let () be the string of length obtained by concatenating the string , the symbol , and again the string , in that order.
-
(c)
Concatenate , in that order, overlapping as much as possible each consecutive pair of strings.
To demonstrate this procedure in the case, start with . Then and , so and . If we concatenate and , overlapping as much as possible, we get , where we overlapped the in the middle of the string. The procedure is illustrated in the case in FigureΒ 1.
The fact that each is a superpermutation on with follows easily via induction, so we donβt present the argument here. The intuition behind why these superpermutations are so efficient is simple β they are the βgreedyβ superpermutations obtained by starting with the string and repeatedly appending as few symbols as possible so as to add a new permutation as a contiguous substring. However, minimality and uniqueness have only been proved when .
It is interesting to observe the circular shift representation of all permutations in the order that they appear in (and indeed, this observation is our primary reason for introducing circular shift representations in the first place). For example, when , the permutations appear in in the order , , , , , ; these have circular shift representations , , , , , and , respectively. In other words, the order of the permutations in is the same as the order we get if we βcountβ in the circular shift representation. It turns out that this is true in general, as demonstrated by the following proposition.
Proposition 3.
Let and be positive integers with . If we write
with for all then the th permutation to appear in as a contiguous substring is .
Before proving PropositionΒ 3, we note that every integer can be written (uniquely) in the desired form β this is just a slight variant on the factorial number system Knu73 in which the digits are allowed to increase from left to right, rather than from right to left.
Proof of PropositionΒ 3.
We prove the result by induction. We already noted that the result is true when , and it is also easily verified when or . We thus move directly to the inductive step.
Suppose that the result holds for a given value of . Then in the construction of given earlier, is the th permutation of symbols that appears in , so by the inductive hypothesis. Then contains permutations of as substrings, the first of which is . The second permutation contained as a substring of is just a cyclic permutation of the first: . Similarly, the third permutation that appears as a substring of is , and so on up to . The result follows. β
3 Non-Uniqueness When
In SectionΒ 4 we present our generalized construction of small superpermutations for arbitrary , but for now we simply present and motivate it in the first non-trivial case (i.e., when ) for clarity.
To start, notice that the first permutations to appear as substrings of are those of the form for some , , and , while the last permutations to appear as substrings of are those of the form . Phrased differently, the first permutations are those in which the symbols and have not been transposed. In other words, when written in one-line notation, if the and are erased, we are left with , , or . Similarly, the last permutations to appear in are those that result in , , or when the and are removed from their one-line representation. Since this property has nothing to do with the order of and in the permutationβs one-line representation, we conclude that a permutation is one of the first (last) permutations to appear as a substring of if and only if interchanging the roles of and in its one-line representation results again in one of the first (last) permutations to appear in .
This leads immediately to the key idea: we can just replace all βs by βs (and vice-versa) in the last half of to generate a new string that is of the same length and is still a superpermutation. These two strings are written in full in TableΒ 2, and it is easily verified by computer that they are indeed distinct superpermutations of length .
4 Generalized Construction
We now show how the idea from SectionΒ 3 extends to the case. While the argument only provides two distinct superpermutations of the conjectured minimal length in the case, our main result shows that the number of small superpermutations produced grows extremely quickly as increases.
Theorem 4.
There are at least
(1) |
distinct (up to relabelling of the symbols) superpermutations on of length .
Before proving the theorem, note that the formulaΒ (1) gives the empty product when , which agrees with the previously-mentioned fact that the minimal superpermutation is unique in these cases. For it gives the values and approximately respectively. A text file containing all small superpermutations described by the theorem in the case can be downloaded from SuperPerm6 . A text file containing all such superpermutations in the case would be larger than terabytes in size and is thus omitted.
The following lemma is our main tool in the proof of the theorem. Before presenting the lemma, we note that each permutation appears in exactly once (AT93, , LemmaΒ 4). It follows that the string defined in the statement of the lemma is unique.
Lemma 5.
Let be integers. For each , let be the shortest substring of that contains each of the th through th permutations to appear in as substrings. Then for all ,
-
(a)
there exists such that the last characters of , in order, are the same as the first characters of ;
-
(b)
the first and last characters of are , and (not necessarily in that order); and
-
(c)
the set of permutations that are substrings of remains unchanged under any interchange of the roles of the symbols in .
Proof.
We first prove properties (a) and (b) by induction. Both of these properties are clearly true by inspection in the case. For the inductive step, assume that the result holds for . If we fix then properties (a) and (b) clearly still hold for by the construction given in SectionΒ 2. To see that properties (a) and (b) also hold for when , simply note that we have in this case, and clearly has both properties.
We now prove property (c) (directly; not via induction). It is a direct consequence of PropositionΒ 3 that there exist fixed such that contains as substrings exactly the permutations whose cyclic shift representations are of the form , where is free to vary from to when . It follows that there exists a fixed permutation on such that is a substring of if and only if deleting the symbols from its one-line representation results in a cyclic permutation of . Since this criterion for being a substring of is clearly independent of the locations of the symbols in the one-line representation of , condition (c) follows. β
Proof of TheoremΒ 4.
Our procedure is to recursively construct the given number of small superpermutations from the well-known superpermutation . Observe that the procedure that we are about to describe reduces exactly to the procedure described in SectionΒ 3 when .
-
(1)
Let and define to be the set of all superpermutations of the desired length that we have constructed so far.
-
(2)
For each and each , let be as in LemmaΒ 5. By the lemma, we can interchange the roles of within the section of that equals without affecting whether or not is a superpermutation. We could do this for each value of from to , however we only do it for the values of that are not multiples of (we will explain the reason for this shortly). Add all of the superpermutations constructed in this way to . The cardinality of is thus multiplied by during this step.
-
(3)
Decrease by .
-
(4)
If , stop. Otherwise, return to step (2).
It is perhaps not clear in step (2) why we only consider the values of that are not divisible by . The reason why we avoid is straightforward: we want all of our superpermutations to start with the substring . The reason why we avoid all other values of that are divisible by is that if we swapped the roles of in the same way for each from to for some , then we would end up with a superpermutation that is the same as one produced in the next iteration of the algorithm (i.e., after we decreased by ). We would thus end up double-counting some superpermutations. As is, in each iteration of the algorithm we alter part of each string that has never been altered before, so we can be sure that each step in the procedure really does produce superpermutations that are not already in the set .
To get the cardinality of the set after the algorithm terminates (i.e., the number of distinct superpermutations that we have constructed), we simply recall that its cardinality is increased by a factor of for each value of from down to . That is, the number of distinct superpermutations that we have constructed is
which can be seen to equal the value given in the statement of the theorem by shifting the value of by . β
5 Conclusions
We have shown that the standard construction of small superpermutations generalizes in a natural way that disproves at least one of two long-standing conjectures. While it is possible that ConjectureΒ 1 is false and ConjectureΒ 2 is true, we consider this possibility rather unlikely, as ConjectureΒ 1 being false would seem to indicate that minimal superpermutations in general do not have as much structure as suggested by the cases. We thus expect that either both conjectures fail, or ConjectureΒ 1 is true and ConjectureΒ 2 is false.
Our results also shed some light on approaches to proving ConjectureΒ 1 that will not work. Upon seeing the abundance of symmetry in the superpermutations in the cases, it is tempting to try to prove that minimal superpermutations must have certain properties that the have. For example, one could try to prove that a minimal superpermutation on must be a palindrome or must contain exactly occurrences of the symbol . However, our generalized construction shows that minimal superpermutations need not have either of these properties.
While computing the length of minimal superpermutations is a fundamental combinatorial problem, and one that can be understood by anyone with even a modest mathematical background, it seems to have received relatively little attention. We hope that our results spark further interest.
Acknowledgements. Thanks are extended to Dan Ashlock for helpful conversations. The author was supported by the University of Guelph Brock Scholarship, the Natural Sciences and Engineering Research Council of Canada, and the Mprime Network.
References
- [1] J. Gallant, D. Maier, and J. A. Storer. On finding minimal length superstrings. Journal of Computer and System Sciences, 20:50β58, 1980.
- [2] M. K. Goldberg and D. T. Lim. A learning algorithm for the shortest superstring problem. In Proceedings of the Atlantic Symposium on Computational Biology and Genome Information Systems and Technology, pages 171β175, 2001.
- [3] H. Kaplan and N. Shafrir. The greedy algorithm for shortest superstrings. Information Processing Letters, 93(1):13β17, 2005.
- [4] T. van Aardenne-Ehrenfest and N.Β G. de Bruijn. Circuits and trees in oriented linear graphs. Simon Stevin, 28:203β217, 1951.
- [5] D. Ashlock and J. Tillotson. Construction of small superpermutations and minimal injective superstrings. Congressus Numerantium, 93:91β98, 1993.
- [6] M. Hamm. Sequence A180632. The On-Line Encyclopedia of Integer Sequences, Sep. 13, 2010, retrieved Oct. 21, 2012. http://oeis.org/A180632
- [7] J. A. Barnett. Permutation Strings, retrieved Oct. 21, 2012. http://www.notatt.com/permutations.pdf
- [8] J. Orendorff. Generate sequence with all permutations. StackOverflow, Feb. 16, 2010, retrieved Oct. 21, 2012. http://stackoverflow.com/a/2274978
- [9] Y. Filmus. What is the shortest string that contains all permutations of an alphabet? Mathematics - Stack Exchange, Dec. 25, 2010, retrieved Oct. 21, 2012. http://math.stackexchange.com/a/15512
- [10] Kolistivra. Turkish Informatics Olympiad problem. TopCoder Forums, Nov. 20, 2007, retrieved Oct. 21, 2012. http://apps.topcoder.com/forums/?module=Thread&threadID=594178
- [11] J. A. Barnett. Re: Integer Strings Containing All Possible Length 4 Sub-Strings. The Math Forum, Aug. 30, 2001, retrieved Oct. 21, 2012. http://mathforum.org/kb/message.jspa?messageID=1689849
- [12] D. E. Knuth. Volume 3: Sorting and Searching. The Art of Computer Programming (3rd ed.), AddisonβWesley, pp. 209, 1973.
- [13] N. Johnston. 96 Small Superpermutations. Published electronically at http://www.njohnston.ca/superperm6.txt, 2012.